local M = {}

M.Name = "Pitch Control"
M.Description = "Slows down, or speeds up a cut."

function M:Operate(Sound)
    local Speed = math.random()*1.5 + 0.5

    local SampleRate = Sound:getSampleRate()
    local Channels = Sound:getChannelCount()
    local Duration = Sound:getSampleCount()/Channels
    print(Duration,Duration/Channels,Sound:getDuration()*SampleRate)

    local NewDuration = math.floor(Duration*Speed)
    local NewSound = love.sound.newSoundData(
        NewDuration,
        SampleRate,
        Sound:getBitDepth(),
        Channels
    )
    Sound:getSample(NewDuration,2)
    for C=1,Channels,1 do
        for I=1,NewDuration,1 do
            local NormalizedI = I/NewDuration
            local SampleIndex = math.floor(NormalizedI*Duration)
            NewSound:setSample(I-1,C,Sound:getSample(SampleIndex-1,C))
        end
    end

    return NewSound
end

return M
