local M = {}

M.Name = "Random Chopping"
M.Description = "Takes a random portion of an existing cut"
M.MaxDuration = 40

local min,max,rand,floor,ceil = math.min,math.max,math.random,math.floor,math.ceil
function M:Operate(Sound)
    local SampleRate = Sound:getSampleRate()
    local Duration = Sound:getSampleCount()
    local Channels = Sound:getChannelCount()

    local Start = max(0,rand(Duration*-0.25,Duration*0.5))
    local End = min(Duration,self.MaxDuration,rand(Duration*0.5,Duration + Duration*0.25))
    Start = floor(Start)
    End = ceil(End)
    print(Start,End)

    local NewSound = love.sound.newSoundData(
        Duration,
        SampleRate,
        Sound:getBitDepth(),
        Sound:getChannelCount()
    )
    for C=1,Channels,1 do
        for I=1,Duration,1 do
            NewSound:setSample(I,C,Sound:getSample(I-Start,C))
        end
    end
    return NewSound
end

return M
